.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include structure_editor.inc

read_structs PROTO :DWORD

.data
;	; 1-st structure members
;	str1  db "DIMENSIONS",0
;	str11 db "x   dd ?",0
;	str12 db "y   dd ?",0
;	str13 db "cx_ dd ?",0
;	str14 db "cy_ dd ?",0
;	str15 db "name db 32 dup (?)"
;	; 2-nd structure members
;	str2  db "PORTRAIT",0
;	str21 db "left   db ?",0
;	str22 db "right  db ?",0
;	str23 db "width  db ?",0
;	str24 db "height db ?",0
;	str25 db "style  dd ?",0
;	str26 db "title  db 32 dup (?)"
;	; 3-rd structure members
;	str3  db "CARTOON",0
;	str31 db "name     db 16 dup (?)",0
;	str32 db "rating   db ?",0
;	str33 db "duration dd ?"
;	str34 db "auditory db  8 dup (?)",0
	
	
;	struct1 dd OFFSET str11,  4, OFFSET str12, 4, OFFSET str13, 4, OFFSET str14, 4, OFFSET str15, 32
;	struct2 dd OFFSET str21,  2, OFFSET str22, 2, OFFSET str23, 2, OFFSET str24, 2, OFFSET str25, 4, OFFSET str26, 32
;	struct3 dd OFFSET str31, 16, OFFSET str32, 2, OFFSET str33, 4, OFFSET str34, 8
	data_buf db 04dh,05ah,090h,000h,003h,000h,000h,000h,004h,000h,000h,000h,0ffh,0ffh,000h,000h
			 db 0b8h,000h,000h,000h,000h,000h,000h,000h,040h,000h,000h,000h,000h,000h,000h,000h
			 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,080h,000h,000h,000h
			 
	rc RECT    <38,23,266,38>
	lf LOGFONT <13,8,0,0,400,0,0,0,0,0,0,CLEARTYPE_QUALITY,0,"Lucida console">
	
	structs_num   dd 0
	struct_active dd 0
	
	
	cur_st_cap    dd 0
	cur_st_mem    dd 0
	cur_st_num    dd 0
	cur_st_max    dd 0
	
	x_data_out    dd 0
	
	del_struct db 10,'>',0
;	structs dd OFFSET str1, OFFSET struct1, 5, 0
;			dd OFFSET str2, OFFSET struct2, 6, 0
;			dd OFFSET str3, OFFSET struct3, 4, 0
	byte_  db " db ",0
	word_  db " dw ",0
	dword_ db " dd ",0
	fword_ db " df ",0
	qword_ db " dq ",0
	tbyte_ db " dt ",0
	
	lookup  db "000102030405060708090A0B0C0D0E0F"
			db "101112131415161718191A1B1C1D1E1F"
			db "202122232425262728292A2B2C2D2E2F"
			db "303132333435363738393A3B3C3D3E3F"
			db "404142434445464748494A4B4C4D4E4F"
			db "505152535455565758595A5B5C5D5E5F"
			db "606162636465666768696A6B6C6D6E6F"
			db "707172737475767778797A7B7C7D7E7F"
			db "808182838485868788898A8B8C8D8E8F"
			db "909192939495969798999A9B9C9D9E9F"
			db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
			db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
			db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
			db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
			db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
			db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"
.data?
	hfont     dd ?
	pHeap     dd ?
	structs   dd ?
	ico_plus  dd ?
	ico_minus dd ?
.code

start:

	invoke GetModuleHandle, 0
	mov	   hInstance, eax
	invoke GetProcessHeap
	mov    pHeap, eax
    invoke InitCommonControls
	invoke DialogBoxParam, hInstance, 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess,0


DlgProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL brush:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL fold:DWORD
	LOCAL buf[32]:BYTE
	LOCAL offs:DWORD
	LOCAL size_:DWORD
	LOCAL x:DWORD
	LOCAL y:DWORD
	LOCAL tem1:DWORD
	LOCAL tem2:DWORD
	LOCAL tem3:DWORD
	LOCAL st_mem:DWORD
	LOCAL st_mem_num:DWORD
	LOCAL st_mem_n:DWORD
	LOCAL data_offs:DWORD
	LOCAL data_size:DWORD
	LOCAL ar_num:DWORD
	
	mov		eax, uMsg
	.if eax==WM_INITDIALOG
		invoke CreateFontIndirect, ADDR lf
		mov    hfont, eax
		invoke read_structs, CADD("structs.txt")
		
		mov    ecx, struct_active
		shl    ecx, 4
		add    ecx, structs
		mov    eax, [ecx+ 0]
		mov    cur_st_cap, eax
		mov    eax, [ecx+ 4]
		mov    cur_st_mem, eax
		mov    eax, [ecx+ 8]
		mov    cur_st_num, eax
		mov    eax, [ecx+12]
		mov    cur_st_max, eax
		mov    ecx, 8
		mul    ecx
		add    eax, 40
		mov    x_data_out, eax
		
		invoke LoadImage, hInstance, 14001, IMAGE_ICON, 12, 12, LR_DEFAULTCOLOR
		mov    ico_plus,  eax
		invoke LoadImage, hInstance, 14002, IMAGE_ICON, 12, 12, LR_DEFAULTCOLOR
		mov    ico_minus, eax

	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		invoke SelectObject, ps.hdc, hfont
		mov    fold, eax
		
		invoke CreateSolidBrush,   0800000h
		mov    brush, eax
		
		mov    x, 10
		mov    y, 10
		mov    offs, 0
		
	;	invoke FrameRect,  ps.hdc, ADDR rc, brush
		invoke SetBkColor, ps.hdc, 0FFB0B0h
		
		invoke TextOut,    ps.hdc, 20, y, cur_st_cap, 64
		invoke DrawIconEx, ps.hdc,  4, y, ico_minus,  12, 12, 0, 0, DI_NORMAL
		add    y, 14
		invoke SetBkColor, ps.hdc, 0FFD0D0h
		
		
		xor    esi, esi
		mov    data_offs, esi
		mov    edi, OFFSET lookup
	@@:
		cmp    esi, cur_st_num
		jz     @F
		invoke SetBkColor, ps.hdc, 0FFD0D0h
		mov    edx, cur_st_mem
		mov    edx, [edx+esi*8]
		invoke TextOut, ps.hdc, 40, y, edx, cur_st_max		
		
		invoke SetBkColor, ps.hdc, 0C0C0C0h
		
		mov    eax, x_data_out
		mov    tem1, eax
		
		mov    edx, cur_st_mem
		mov    edx, [edx+esi*8+4]
		mov    ecx, edx
		shr    ecx, 16
		mov    ar_num, ecx
		and    edx, 0ffffh
		mov    data_size, edx
		
		@out_array:
		
		mov    edx,  data_size
		mov    tem2, edx
		sub    ar_num, 1
		
		@out_byte:
		sub    tem2, 1
		xor    eax, eax
		mov    ecx, tem2
		add    ecx, data_offs
		mov     al, BYTE PTR [data_buf+ecx]
		add    eax, eax
		add    eax, edi
		
		invoke TextOut, ps.hdc, tem1, y, eax, 2
		
		add    tem1,  16
		cmp    tem2,   0
		jnz    @out_byte
		
		mov    edx, data_size
		add    data_offs, edx
		
		mov    ecx, ar_num
		mov    edx, ecx
		shr    ecx, 1
		shl    ecx, 1
		
		.if ecx == edx
			mov    ecx, 0C0C0C0h
		.else
			mov    ecx, 0909090h
		.endif
		
		invoke SetBkColor, ps.hdc, ecx
			
		cmp    ar_num, 0
		jnz    @out_array
		
		add    y, 14
		inc    esi
		jmp    @B
	@@:
		
		invoke SetBkColor, ps.hdc, 0FFB0B0h
		xor    esi, esi
		@@:
		cmp    esi, structs_num
		jz     @F
		cmp    esi, struct_active
		jz     @active
		mov    ecx, esi
		shl    ecx, 4
		add    ecx, structs
		mov    edx, [ecx+0]
		invoke TextOut,    ps.hdc, 20, y, edx, 64
		invoke DrawIconEx, ps.hdc,  4, y, ico_plus, 12, 12, 0, 0, DI_NORMAL
		add    y, 14
		@active:
		inc    esi
		jmp    @B
		@@:
		
		invoke DeleteObject, brush
		invoke SelectObject, ps.hdc, fold
		invoke EndPaint, hWin, ADDR ps
		
	.elseif eax==WM_COMMAND

;	.elseif eax==WM_MOUSEMOVE
;		mov    eax, lParam
;		mov    ecx, eax
;		and    ecx, 0ffffh
;		shr    eax, 16
;		.if ecx > 24
;			sub    eax, 24
;			mov    ecx, 14
;			xor    edx, edx
;			div    ecx
;			mov    edx, cur_st_num
;			dec    edx
;			.if eax > edx
;				mov    eax, edx
;			.endif
;			mul    ecx
;			add    eax, 23
;			.if rc.top != eax
;				mov    rc.top, eax
;				add    eax, 15
;				mov    rc.bottom, eax
;				invoke InvalidateRect, hWin, 0, 0
;			.endif
;		.endif
		
	.elseif eax==WM_LBUTTONDOWN
		mov    eax, cur_st_num
		mov    ecx, 14
		mul    ecx
		add    eax, 24
		mov    tem1, eax
		
		mov    eax, lParam
		shr    eax, 16
		
		.if eax > tem1
			sub    eax, tem1
			mov    ecx, 14
			xor    edx, edx
			div    ecx
			
			mov    ecx, structs_num
			dec    ecx
			.if eax < ecx
				
				.if eax >= struct_active
					inc    eax
				.endif
				mov    struct_active, eax
				
				mov    ecx, eax
				shl    ecx, 4
				add    ecx, structs
				mov    eax, [ecx+ 0]
				mov    cur_st_cap, eax
				mov    eax, [ecx+ 4]
				mov    cur_st_mem, eax
				mov    eax, [ecx+ 8]
				mov    cur_st_num, eax
				mov    eax, [ecx+12]
				mov    cur_st_max, eax
				mov    ecx, 8
				mul    ecx
				add    eax, 40
				mov    x_data_out, eax
				
				invoke InvalidateRect, hWin, 0, 1
				
			.endif			
		.endif
		
	.elseif eax==WM_CLOSE
		; the most painfull heap-free starts here		
		mov    esi, structs_num
		
		@free_struct:
		cmp    structs_num, 0
		jz     @free_str_done
		sub    structs_num, 1
		
		mov    eax, structs_num
		shl    eax, 4
		add    eax, structs
		mov    ecx, [eax+0]
		push   eax
		invoke HeapFree, pHeap, 0, ecx ; struct_title freed
		pop    eax
		
		mov    esi, [eax+4] ; struct_N ; 2-nd to free
		mov    edi, [eax+8] ; number of struct_member
		
		@free_member:
			test   edi, edi
			jz     @free_mem_done
			dec    edi
			mov    ecx, [esi+edi*8]
			invoke HeapFree, pHeap, 0, ecx ; struct_N.member_N freed
			jmp    @free_member
		@free_mem_done:
		invoke HeapFree, pHeap, 0, esi; struct_N freed
		jmp    @free_struct
		@free_str_done:
		invoke HeapFree,     pHeap, 0, structs ; structs freed
		; the most painfull heap-free ends here		
		
		invoke DeleteObject, hfont
		invoke DeleteObject, ico_plus
		invoke DeleteObject, ico_minus
		invoke EndDialog,    hWin, 0
	.else
		mov		eax, 0
		ret
	.endif
	mov		eax, 1
	ret

DlgProc endp

read_structs proc uses edi esi file_name:DWORD
	LOCAL hFile:DWORD
	LOCAL fSize:DWORD
	LOCAL file_buf:DWORD
	LOCAL offs:DWORD
	LOCAL st_mems_num:DWORD
	LOCAL st_cur:DWORD
	LOCAL st_cur_mem:DWORD
	LOCAL st_cur_title:DWORD
	LOCAL buf[64]:BYTE
	LOCAL tem1:DWORD
	LOCAL tem2:DWORD
	LOCAL tem3:DWORD
	LOCAL tem4:DWORD
	LOCAL type_size:DWORD
	LOCAL mem_max:DWORD
	
	mov    hFile, fopen(file_name)
	invoke GetFileSize, eax, 0
	mov    fSize, eax
	add    eax, 1
	invoke HeapAlloc, pHeap, 0, eax
	mov    file_buf, eax
	mov    esi, eax
	mov    ecx, fread(hFile, esi, fSize)
	mov    BYTE PTR [esi+ecx], 0
	;-- figure out number of structures & allocate memory
	invoke szWcnt, esi, ADDR del_struct ; count "\n>"
	mov    structs_num, eax
	test   eax, eax
	jz     @game_over
	shl    eax, 4 ; each record holds 4 DWORDs
	invoke HeapAlloc, pHeap, 0, eax
	mov    structs, eax
	;--
	mov    offs, 1
	xor    edi, edi
;00000000000000000000000000000000000000000000000000000000000000
	@next_struct:
	cmp    edi, structs_num
	jz     @structs_enum_done
	
	invoke InString, offs, esi, ADDR del_struct ; find "\n>"
	inc    eax
	mov    offs, eax
	
	xor    ecx, ecx
	@@:
	mov    dx, [esi+eax]
	cmp    dx, 3C0Ah
	jz     @F
	cmp    dx, 0A0Dh
	jnz    @no_new_member
	;---> save pointers for later reference
	mov    edx, eax
	add    edx, esi
	push   edx
	;--->
	inc    ecx
	@no_new_member:
	inc    eax
	jmp    @B
	@@:
	
	dec    ecx ; number of struct_members
	
	mov    edx, edi
	shl    edx, 4
	add    edx, structs
	mov    st_cur,  edx
	mov    [edx+8], ecx   ; save number of struct_members
	
	mov    st_mems_num,  ecx
	;-- allocate memory for struct_N: ecx*2*4 bytes
	shl    ecx, 3
	invoke HeapAlloc, pHeap, 0, ecx
	mov    edx, st_cur
	mov    [edx+4], eax   ; save pointer to struct_N
	mov    st_cur_mem, eax
	;-- allocate memory for title of struct_N
	invoke HeapAlloc, pHeap, HEAP_ZERO_MEMORY, 64
	mov    edx, st_cur
	mov    [edx+0], eax   ; save pointer to struct_N title
	mov    st_cur_title, eax
	;-- allocate memory for all struct_N.member_N: each 64 bytes
	xor    ecx, ecx
	@@:
	cmp    ecx, st_mems_num
	jz     @F
	push   ecx
	invoke HeapAlloc, pHeap, HEAP_ZERO_MEMORY, 64
	pop    ecx
	mov    edx, st_cur_mem
	mov    [edx+ecx*8], eax
	inc    ecx
	jmp    @B
	@@:
	;-- read members & determine size
	mov    mem_max, 0
	pop    edx ; points at the end of structure just before < (should be pop'ed for empty structure as well)
	mov    tem1, edx
	mov    eax, st_mems_num
	mov    tem2, eax
	@@:
	cmp    tem2, 0
	jz     @F
	sub    tem2, 1
	pop    edx
	mov    ecx, tem1
	sub    ecx, edx
	mov    tem1, edx
	mov    edx, st_cur_mem
	mov    eax, tem2
	mov    edx, [edx+eax*8]
	mov    tem3, edx
	.if ecx > mem_max
		mov    mem_max, ecx
	.endif
	invoke szLeft, tem1, edx, ecx
	;--save size of struct_member
	invoke InString, 1, tem3, ADDR byte_
	mov    ecx, 1
	cmp    eax, 0
	jg     @type_done
	invoke InString, 1, tem3, ADDR word_
	mov    ecx, 2
	cmp    eax, 0
	jg     @type_done
	invoke InString, 1, tem3, ADDR dword_
	mov    ecx, 4
	cmp    eax, 0
	jg     @type_done
	invoke InString, 1, tem3, ADDR fword_
	mov    ecx, 6
	cmp    eax, 0
	jg     @type_done
	invoke InString, 1, tem3, ADDR qword_
	mov    ecx, 8
	cmp    eax, 0
	jg     @type_done
	invoke InString, 1, tem3, ADDR tbyte_
	mov    ecx, 10
	@type_done:
	
	mov    type_size, ecx
	mov    ecx, eax
	add    ecx, tem3
	add    ecx, 2
	
	@check_array1:
	inc    ecx
	mov    al, BYTE PTR [ecx]
	.if al != 09h || al != 20h
		.if al == '?'
			mov    ecx, 1
			jmp    @check_array_done
		.endif
		push   ecx
		jmp    @check_array2
	.endif
	jmp    @check_array1
	
	@check_array2:
	inc    ecx
	mov    al, BYTE PTR [ecx]
	.if al == 09h || al == 20h
		pop    edx
		sub    ecx, edx
		invoke szLeft, edx, ADDR buf, ecx
		invoke atodw, ADDR buf
		mov    ecx, eax
		jmp    @check_array_done
	.endif
	jmp    @check_array2
	@check_array_done:
	
	mov    eax, type_size
	shl    ecx, 16
	or     eax, ecx

	mov    edx, st_cur_mem
	mov    ecx, tem2
	mov    [edx+ecx*8+4], eax

	jmp    @B
	@@:
	;-- save max member character count
	mov    edx, st_cur
	mov    eax, mem_max
	mov    [edx+12], eax
	;-- read & save struct_title
	mov    edx, tem1
	@@:
	dec    edx
	cmp    BYTE PTR [edx], '>'
	jnz    @B
	
	inc    edx
	mov    ecx, tem1
	sub    ecx, edx
	invoke szLeft, edx, st_cur_title, ecx
	;--	
	
	inc    edi
	jmp    @next_struct
;00000000000000000000000000000000000000000000000000000000000000
	@structs_enum_done:

	;--
	@game_over:
	invoke HeapFree, pHeap, 0, file_buf
	fclose(hFile)
	
	ret

read_structs endp

end start
